function [c]=connectedComponents(UpperThresh, LowerThresh, corrH, corrV, corrD1, corrD2)
% example: 8 neighbours and  0.5 threshold: c=connectedComponents(2 , 0.5, corrH, corrV, corrD1, corrD2); 
% example: 4 neighbours and  0.5 threshold: c=connectedComponents(2 , 0.5, corrH, corrV, [], []); 

% UpperThresh - used only in collecting small clusters

[rows,cols]=size(corrH);

[I,J]=find( corrH > LowerThresh & corrH < UpperThresh );
ind=[(J-1)*rows+I J*rows+I];

[I,J]=find( corrV > LowerThresh & corrV < UpperThresh );
ind=[ind; (J-1)*rows+I (J-1)*rows+I+1];

[I,J]=find( corrD1 > LowerThresh & corrD1 < UpperThresh );
ind=[ind; (J-1)*rows+I J*rows+I+1];

[I,J]=find( corrD2 > LowerThresh & corrD2 < UpperThresh );
ind=[ind; (J-2)*rows+I+1 (J-1)*rows+I];

[i,j]=find(ind>rows*cols | ind<=0);
ind(i,:)=[];

cluster=unionfind(ind,rows*cols);
c=reshape(cluster,rows,cols);










