clear all

im=double(imread(['3096.tif']))/255;
%im=im(21:36,21:36,:);


nIters = 10; % number of GBP iterations
nColors = 6;  % number of potts states
Tmin=100;
Tmax=1000;
deltaT=50;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 4 neib
% calculate the pairwise similarities
[SimHorizontal4,SimVertical4,SimDiagonal1,SimDiagonal2]=...
    imageSimAssafStyle2(im, 'color', 4);

% run GBP and calculate the correlations
corr4=runGBP(4, nColors, nIters, Tmin, Tmax, deltaT, ...
	   SimHorizontal4, SimVertical4, SimDiagonal1, SimDiagonal2);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 8 neib
% calculate the pairwise similarities
[SimHorizontal8,SimVertical8,SimDiagonal18,SimDiagonal28]=...
    imageSimAssafStyle2(im, 'color', 8);

% run GBP and calculate the correlations
corr8=runGBP(8, nColors, nIters, Tmin, Tmax, deltaT, ...
	   SimHorizontal8, SimVertical8, SimDiagonal18, SimDiagonal28);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   

numClusters=10; % number of clusters to display
T=Tmin:deltaT:Tmax;

for i=1:length(T)
	plotSeg(im,corr4{i},numClusters,1);
	title(['4 neighbours, Temp: ',num2str(T(i))]);
	pause;clf
end

for i=1:length(T)
	plotSeg(im,corr8{i},numClusters,2);
	title(['8 neighbours, Temp: ',num2str(T(i))]);
	pause;clf
end





